    View Javadoc
    1   package org.apache.bcel.classfile;
    2
    3   /* ====================================================================
    4    * The Apache Software License, Version 1.1
    5    *
    6    * Copyright (c) 2001 The Apache Software Foundation.  All rights
    7    * reserved.
    8    *
    9    * Redistribution and use in source and binary forms, with or without
    10   * modification, are permitted provided that the following conditions
    11   * are met:
    12   *
    13   * 1. Redistributions of source code must retain the above copyright
    14   *    notice, this list of conditions and the following disclaimer.
    15   *
    16   * 2. Redistributions in binary form must reproduce the above copyright
    17   *    notice, this list of conditions and the following disclaimer in
    18   *    the documentation and/or other materials provided with the
    19   *    distribution.
    20   *
    21   * 3. The end-user documentation included with the redistribution,
    22   *    if any, must include the following acknowledgment:
    23   *       "This product includes software developed by the
    24   *        Apache Software Foundation (http://www.apache.org/)."
    25   *    Alternately, this acknowledgment may appear in the software itself,
    26   *    if and wherever such third-party acknowledgments normally appear.
    27   *
    28   * 4. The names "Apache" and "Apache Software Foundation" and
    29   *    "Apache BCEL" must not be used to endorse or promote products
    30   *    derived from this software without prior written permission. For
    31   *    written permission, please contact apache@apache.org.
    32   *
    33   * 5. Products derived from this software may not be called "Apache",
    34   *    "Apache BCEL", nor may "Apache" appear in their name, without
    35   *    prior written permission of the Apache Software Foundation.
    36   *
    37   * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
    38   * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
    39   * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    40   * DISCLAIMED.  IN NO EVENT SHALL THE APACHE SOFTWARE FOUNDATION OR
    41   * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    42   * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    43   * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
    44   * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
    45   * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
    46   * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    47   * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    48   * SUCH DAMAGE.
    49   * ====================================================================
    50   *
    51   * This software consists of voluntary contributions made by many
    52   * individuals on behalf of the Apache Software Foundation.  For more
    53   * information on the Apache Software Foundation, please see
    54   * <http://www.apache.org/>;.
    55   */
    56  import java.io.*;
    57  import  org.apache.bcel.Constants;
    58
    59  /***
    60   * Abstract super class for Fieldref and Methodref constants.
    61   *
    62   * @version $Id: ConstantCP.java,v 1.2 2002/03/11 16:16:35 mdahm Exp $
    63   * @author  <A HREF="mailto:markus.dahm@berlin.de">M. Dahm</A>
    64   * @see     ConstantFieldref
    65   * @see     ConstantMethodref
    66   * @see     ConstantInterfaceMethodref
    67   */
    68  public abstract class ConstantCP extends Constant {
    69    /*** References to the constants containing the class and the field signature
    70     */
    71    protected int class_index, name_and_type_index;
    72
    73    /***
    74     * Initialize from another object.
    75     */
    76    public ConstantCP(ConstantCP c) {
    77      this(c.getTag(), c.getClassIndex(), c.getNameAndTypeIndex());
    78    }
    79
    80    /***
    81     * Initialize instance from file data.
    82     *
    83     * @param tag  Constant type tag
    84     * @param file Input stream
    85     * @throws IOException
    86     */
    87    ConstantCP(byte tag, DataInputStream file) throws IOException
    88    {
    89      this(tag, file.readUnsignedShort(), file.readUnsignedShort());
    90    }
    91
    92    /***
    93     * @param class_index Reference to the class containing the field
    94     * @param name_and_type_index and the field signature
    95     */
    96    protected ConstantCP(byte tag, int class_index,
    97  		       int name_and_type_index) {
    98      super(tag);
    99      this.class_index         = class_index;
    100     this.name_and_type_index = name_and_type_index;
    101   }
    102
    103   /***
    104    * Dump constant field reference to file stream in binary format.
    105    *
    106    * @param file Output file stream
    107    * @throws IOException
    108    */
    109   public final void dump(DataOutputStream file) throws IOException
    110   {
    111     file.writeByte(tag);
    112     file.writeShort(class_index);
    113     file.writeShort(name_and_type_index);
    114   }
    115
    116   /***
    117    * @return Reference (index) to class this field or method belongs to.
    118    */
    119   public final int getClassIndex()       { return class_index; }
    120
    121   /***
    122    * @return Reference (index) to signature of the field.
    123    */
    124   public final int getNameAndTypeIndex() { return name_and_type_index; }
    125
    126   /***
    127    * @param class_index points to Constant_class
    128    */
    129   public final void setClassIndex(int class_index) {
    130     this.class_index = class_index;
    131   }
    132
    133   /***
    134    * @return Class this field belongs to.
    135    */
    136   public String getClass(ConstantPool cp) {
    137     return cp.constantToString(class_index, Constants.CONSTANT_Class);
    138   }
    139
    140   /***
    141    * @param name_and_type_index points to Constant_NameAndType
    142    */
    143   public final void setNameAndTypeIndex(int name_and_type_index) {
    144     this.name_and_type_index = name_and_type_index;
    145   }
    146
    147   /***
    148    * @return String representation.
    149    */
    150   public final String toString() {
    151     return super.toString() + "(class_index = " + class_index +
    152       ", name_and_type_index = " + name_and_type_index + ")";
    153   }
    154 }

This page was automatically generated by Maven